summaryrefslogtreecommitdiffstats
path: root/13.0-rc/apache/entrypoint.sh
diff options
context:
space:
mode:
Diffstat (limited to '13.0-rc/apache/entrypoint.sh')
-rwxr-xr-x13.0-rc/apache/entrypoint.sh60
1 files changed, 60 insertions, 0 deletions
diff --git a/13.0-rc/apache/entrypoint.sh b/13.0-rc/apache/entrypoint.sh
new file mode 100755
index 00000000..0568aac1
--- /dev/null
+++ b/13.0-rc/apache/entrypoint.sh
@@ -0,0 +1,60 @@
+#!/bin/bash
+set -e
+
+# version_greater A B returns whether A > B
+function version_greater() {
+ [[ "$(printf '%s\n' "$@" | sort -V | head -n 1)" != "$1" ]];
+}
+
+# return true if specified directory is empty
+function directory_empty() {
+ [ -n "$(find "$1"/ -prune -empty)" ]
+}
+
+function run_as() {
+ if [[ $EUID -eq 0 ]]; then
+ su - www-data -s /bin/bash -c "$1"
+ else
+ bash -c "$1"
+ fi
+}
+
+installed_version="0.0.0~unknown"
+if [ -f /var/www/html/version.php ]; then
+ installed_version=$(php -r 'require "/var/www/html/version.php"; echo implode(".", $OC_Version);')
+fi
+image_version=$(php -r 'require "/usr/src/nextcloud/version.php"; echo implode(".", $OC_Version);')
+
+if version_greater "$installed_version" "$image_version"; then
+ echo "Can't start Nextcloud because the version of the data ($installed_version) is higher than the docker image version ($image_version) and downgrading is not supported. Are you sure you have pulled the newest image version?"
+ exit 1
+fi
+
+if version_greater "$image_version" "$installed_version"; then
+ if [ "$installed_version" != "0.0.0~unknown" ]; then
+ run_as 'php /var/www/html/occ app:list' > /tmp/list_before
+ fi
+ if [[ $EUID -eq 0 ]]; then
+ rsync_options="-rlDog --chown www-data:root"
+ else
+ rsync_options="-rlD"
+ fi
+ rsync $rsync_options --delete --exclude /config/ --exclude /data/ --exclude /custom_apps/ --exclude /themes/ /usr/src/nextcloud/ /var/www/html/
+
+ for dir in config data custom_apps themes; do
+ if [ ! -d /var/www/html/"$dir" ] || directory_empty /var/www/html/"$dir"; then
+ rsync $rsync_options --include /"$dir"/ --exclude '/*' /usr/src/nextcloud/ /var/www/html/
+ fi
+ done
+
+ if [ "$installed_version" != "0.0.0~unknown" ]; then
+ run_as 'php /var/www/html/occ upgrade --no-app-disable'
+
+ run_as 'php /var/www/html/occ app:list' > /tmp/list_after
+ echo "The following apps have beed disabled:"
+ diff <(sed -n "/Enabled:/,/Disabled:/p" /tmp/list_before) <(sed -n "/Enabled:/,/Disabled:/p" /tmp/list_after) | grep '<' | cut -d- -f2 | cut -d: -f1
+ rm -f /tmp/list_before /tmp/list_after
+ fi
+fi
+
+exec "$@"